*-----------------------------------------------------------
* Program Number:	BLOCKS
* Written by    :	Brian Martin
* Date Created  :	4-17-2004
* Description   :
*
*-----------------------------------------------------------
START	ORG	$1000

***Plays a sound file from memory -- the parameter passed is the reference number to the sound file
PLAY	MACRO
	MOVE.B	#72,D0
	MOVE.B	\1,D1
	TRAP	#15
	ENDM


BLUE	EQU	$00FF0000
DARK_GREEN	EQU	$0000AA00
GREEN	EQU	$0000FF00
RED	EQU	$000000FF
PURPLE	EQU	$00800080	
YELLOW	EQU	$0000FFFF
BLACK	EQU	$00000000
WHITE	EQU	$00FFFFFF

	MOVE.L	#0,POINTS
	MOVE.B	#1,LEVEL_NUM
	MOVE.W	#3,NUM_BALLS
	MOVE.W	#1,XDIRECTION
	MOVE.W	#1,YDIRECTION
	MOVE.L	#BLACK,TEXT_COLOR
	MOVE.B	#40,BLOCK_NUM
	MOVE.L	#BLACK,ERASE
	MOVE.W	#32,HEIGHT_B	height of a block
	MOVE.W	#64,WIDTH_B	width of a block
	MOVE.W	#400,YPADDLE	y-position of paddle
	MOVE.W	#40,PADDLE_MOVE	amount paddle moves at a time
	MOVE.W	#175,XPADDLE	starting paddle position
	MOVE.W	#20,DIAMETER	diameter of ball
	MOVE.W	#100,X	starting x-position of ball
	MOVE.W	#300,Y	starting y-position of ball
	MOVE.L	#GREEN,BALL_COLOR
	MOVE.W	#1050,TIME	#of times to execute stall loop (min. 1)
	MOVE.W	#1,XMOVE	y-movement of ball
	MOVE.W	#1,YMOVE	x-movement of ball
	MOVE.W	#-1,DIRECTION	
	MOVE.W	#70,WIDTH	width of paddle
	MOVE.W	#10,HEIGHT	height of paddle
	MOVE.W	BALL_COLOR,P_COLOR
	MOVE.W	TIME,D0
	DIVU.W	#5,D0
	MOVE.W	D0,SPEED_DIFF

***Populate ROW_COLOR array with the color of each row of blocks***
	LEA	ROW_COLOR,A0
	MOVE.L	#BLUE,(A0)	
	MOVE.L	#RED,(4,A0)
	MOVE.L	#YELLOW,(8,A0)
	MOVE.L	#DARK_GREEN,(12,A0)
*******************************************************************

	
***Populate XBLOCK array with x-position for each column of block***
	LEA	XBLOCK,A1
	
	MOVE.W	#0,D0
FOR_LOOP	
	MOVE.W	WIDTH_B,D2
	ADD.W	#1,D2
	MOVE.W	#2,D3
	MULU.W	D0,D3
	MULU.W	D0,D2
	MOVE.W	D2,(A1,D3.W)
	ADD.W	#1,D0
	CMP.W	#10,D0
	BNE	FOR_LOOP
*******************************************************************


***Populate YBLOCK array with y-position for each row of blocks****
	LEA	YBLOCK,A1
	MOVE.W	#0,D0
FOR_LOOP2	
	MOVE.W	HEIGHT_B,D2
	ADD.W	#1,D2
	MOVE.W	#2,D3
	MULU.W	D0,D3
	MULU.W	D0,D2
	MOVE.W	D2,(A1,D3.W)
	ADD.W	#1,D0
	CMP.W	#4,D0
	BNE	FOR_LOOP2
********************************************************************

	


***Load sounds into memory****
	LEA	SOUND,A1
	MOVE.B	#1,D1
	MOVE.B	#71,D0
	TRAP	#15

	LEA	SOUND2,A1
	MOVE.B	#2,D1
	MOVE.B	#71,D0
	TRAP	#15

	LEA	SOUND3,A1
	MOVE.B	#3,D1
	MOVE.B	#71,D0
	TRAP	#15

**************************************************	
	

***Turn off keyboard echo****
	MOVE.B	#0,D1
	MOVE.B	#12,D0
	TRAP	#15
*****************************



LEVEL_UP
***Display Blocks***********************************

	LEA	ROW_COLOR,A0
	LEA	YBLOCK,A1
	LEA	XBLOCK,A2
	MOVE.W	#0,D0
FOR_LOOP3	MOVE.W	#4,D2
	MULU.W	D0,D2
	PEA	(A0,D2.W)
	BSR	COLOR
	LEA	(4,A7),A7
	MOVE.W	#0,D1
FOR_LOOP4	MOVE.W	#2,D3
	MOVE.W	#2,D4
	MULU.W	D0,D3
	MULU.W	D1,D4
	PEA	(A2,D4.W)
	PEA	(A1,D3.W)
	BSR	BLOCK
	LEA	(8,A7),A7
	ADD.W	#1,D1
	CMP.W	#10,D1
	BNE	FOR_LOOP4
	ADD.W	#1,D0
	CMP.W	#4,D0
	BNE	FOR_LOOP3
**************************************************







RESTART	BSR	SCORE


	PEA	ERASE
	BSR	COLOR
	LEA	(4,A7),A7
	
	PEA	XPADDLE
	BSR	PADDLE	erase paddle
	LEA	(4,A7),A7


	MOVE.W	#1,XDIRECTION
	MOVE.W	#1,YDIRECTION
	MOVE.W	#175,XPADDLE	starting paddle position
	MOVE.W	#100,X	starting x-position of ball
	MOVE.W	#300,Y	starting y-position of ball

	PEA	TEXT_COLOR
	BSR	COLOR
	LEA	(4,A7),A7

	MOVE.B	#11,D0
	MOVE.W	#$2010,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	START_MES,A1
	TRAP	#15


STALL_START	MOVE.B	#7,D0
	TRAP	#15
	CMP.B	#1,D1
	BNE	STALL_START
	MOVE.B	#5,D0
	TRAP	#15
	CMP.B	#$35,D1
	BNE	STALL_START


	MOVE.B	#11,D0
	MOVE.W	#$2010,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	CLEAR_MES,A1
	TRAP	#15





	PEA	BALL_COLOR
	BSR	COLOR
	LEA	(4,A7),A7
	PEA	XPADDLE
	BSR	PADDLE	draw paddle
	LEA	(4,A7),A7


***All game-play takes place inside of this loop******
LOOP	MOVE.W	NUM_BALLS,D7
	PEA	BALL_COLOR
	BSR	COLOR
	LEA	(4,A7),A7
	BSR	MOVE_BALL	Calculate next position of the ball

	BSR	P_MOVE

	BSR	P_MOVE

	PEA	X
	PEA	Y
	BSR	CIRCLE	draw the ball
	LEA	(8,A7),A7

	BSR	P_MOVE	check for input and move paddle accordingly	
	BSR	LEFT	check for collision
	BSR	RIGHT	check for collision
	BSR	BOTTOM	check for collision
	BSR	TOP	check for collision


	PEA	TIME	
	BSR	STALL	slows the ball down
	LEA	(4,A7),A7
	
	BSR	P_MOVE
	
	PEA	ERASE
	BSR	COLOR
	LEA	(4,A7),A7


	PEA	X
	PEA	Y
	BSR	CIRCLE	erase the ball
	LEA	(8,A7),A7
	CMP.B	#0,BLOCK_NUM
	BEQ	NO_BLOCKS
	CMP.W	NUM_BALLS,D7
	BEQ	LOOP
******************************************************

	CMP.W	#0,NUM_BALLS
	BNE	RESTART
	BRA	GAME_OVER
NO_BLOCKS

	ADD.B	#1,LEVEL_NUM
	MOVE.W	SPEED_DIFF,D0
	MOVE.W	TIME,D1
	SUB.W	D0,D1
	MOVE.W	D1,TIME
	
	MOVE.B	#40,BLOCK_NUM
	ADD.W	#1,NUM_BALLS


PLAY_TADA	
	PLAY	#3
	CMP.W	#0,D0
	BEQ	PLAY_TADA
	MOVE.L	#0,D0
	MOVE.L	#0,D1
	MOVE.W	#100,D0
	MOVE.W	NUM_BALLS,D1
	MULS.W	D1,D0
	ADD.L	D0,POINTS
	BRA	LEVEL_UP


GAME_OVER
	
	BSR	SCORE
	PEA	TEXT_COLOR
	BSR	COLOR
	LEA	(4,A7),A7

	MOVE.B	#11,D0
	MOVE.W	#$2010,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	OVER_MES,A1
	TRAP	#15

	MOVE.L	#0,D0

OVER_STALL2	ADD.L	#1,D0
	CMP.L	#$FFFFF,D0
	NOP
	NOP
	NOP
	NOP
	NOP
	BNE	OVER_STALL2





	STOP	#$2000



SCORE	MOVEM.L	D0-D2/A1,-(A7)
	PEA	TEXT_COLOR
	BSR	COLOR
	LEA	(4,A7),A7

	MOVE.B	#11,D0
	MOVE.W	#31,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	CLEAR_MES,A1
	TRAP	#15

	MOVE.B	#11,D0
	MOVE.W	#31,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	MESSAGE,A1
	TRAP	#15



	MOVE.B	#15,D0
	MOVE.B	#10,D2
	MOVE.L	#0,D1
	MOVE.W	NUM_BALLS,D1
	TRAP	#15


	MOVE.B	#11,D0
	MOVE.W	#$151F,D1
	TRAP	#15
	
	MOVE.B	#14,D0
	LEA	SCORE_MES,A1
	TRAP	#15

	MOVE.B	#15,D0
	MOVE.B	#10,D2
	MOVE.L	#0,D1
	MOVE.L	POINTS,D1
	TRAP	#15


	MOVE.B	#11,D0
	MOVE.W	#$451F,D1
	TRAP	#15

	MOVE.B	#14,D0
	LEA	LEVEL_MES,A1
	TRAP	#15



	MOVE.B	#15,D0
	MOVE.B	#10,D2
	MOVE.L	#0,D1
	MOVE.B	LEVEL_NUM,D1
	TRAP	#15




	MOVEM.L	(A7)+,D0-D2/A1
	RTS




****Draws a single block at (A0,A1)*******************
BLOCK	MOVEM.L	D0-D4/A0-A1,-(A7)
	MOVE.L	(32,A7),A1
	MOVE.L	(36,A7),A0
	MOVE.W	(A1),D2
	MOVE.W	(A0),D1
	MOVE.L	#87,D0
	MOVE.W	D1,D3
	MOVE.W	D2,D4
	ADD.W	WIDTH_B,D3
	ADD.W	HEIGHT_B,D4
	TRAP	#15
	MOVEM.L	(A7)+,D0-D4/A0-A1
	RTS
******************************************************


***Check for user input and move the paddle according to the user's input****
P_MOVE	MOVEM.L	D0-D1,-(A7)
	MOVE.B	#7,D0
	TRAP	#15	check for user input
	CMP.B	#1,D1
	BNE	PMOVE_SKIP2	get user input if there is any
	MOVE.B	#5,D0
	TRAP	#15
	CMP.B	#$36,D1
	BNE	PMOVE_SKIP1	if input is '6' move paddle right
	
	PEA	ERASE
	BSR	COLOR
	LEA	(4,A7),A7
	
	PEA	XPADDLE
	BSR	PADDLE	erase paddle
	LEA	(4,A7),A7
	MOVE.W	PADDLE_MOVE,D0
	ADD.W	D0,XPADDLE	calculate new paddle position
	
	PEA	BALL_COLOR
	BSR	COLOR
	LEA	(4,A7),A7

	PEA	XPADDLE
	BSR	PADDLE	redraw paddle
	LEA	(4,A7),A7	


PMOVE_SKIP1
	CMP.B	#$34,D1
	BNE	PMOVE_SKIP2	if user input is '4' move paddle left

	PEA	ERASE
	BSR	COLOR
	LEA	(4,A7),A7
	
	PEA	XPADDLE
	BSR	PADDLE	erase paddle
	LEA	(4,A7),A7
	MOVE.W	PADDLE_MOVE,D0
	SUB.W	D0,XPADDLE	calculate new paddle position
	
	PEA	BALL_COLOR
	BSR	COLOR	
	LEA	(4,A7),A7

	
	BSR	PADDLE	redraw paddle
	

PMOVE_SKIP2	MOVEM.L	(A7)+,D0-D1
	RTS
*****************************************************************************




ERASE_BLOCK
	MOVEM.L	D0-D3/A0-A2,-(A7)
	LEA	ROW_COLOR,A1
	MOVE.W	#0,D0
	MOVE.L	(32,A7),A2
	MOVE.L	(36,A7),A0
ERASE_LOOP	
	MOVE.W	#4,D1
	MULU.W	D0,D1
	MOVE.L	(A1,D1.W),D2
	CMP.L	(A0),D2
	BEQ	FIND_POINT
	ADD.W	#1,D0
	CMP.W	#4,D0
	BNE	ERASE_LOOP
	BRA	ERASE_SKIP
FIND_POINT		
	SUB.B	#1,BLOCK_NUM
	ADD.L	#25,POINTS
	BSR	SCORE
	LEA	YBLOCK,A1
	MULU.W	#2,D0
	MOVE.W	(A1,D0.W),D2
	LEA	XBLOCK,A1
	MOVE.W	#9,D0
ERASE_LOOP2	MOVE.W	#2,D1
	MULU.W	D0,D1
	SUB.W	#1,D0
	MOVE.W	(A1,D1.W),D3
	CMP.W	(A2),D3
	BLE	EXIT_ERASE
	CMP.W	#-1,D0
	BNE	ERASE_LOOP2	

EXIT_ERASE	
	ADD.W	#1,D0
	MULU.W	#2,D0
	MOVE.W	(A1,D0),D1
	

	
	MOVE.W	D1,(A2)
	MOVE.W	D2,ERASEY
	PEA	ERASE
	BSR	COLOR
	LEA	(4,A7),A7
	
	PEA	ERASEX
	PEA	ERASEY
	BSR	BLOCK
	LEA	(8,A7),A7


ERASE_SKIP	MOVEM.L	(A7)+,D0-D3/A0-A2
	RTS

***Draw Paddle*************************
PADDLE	MOVEM.L	D0-D4/A1,-(A7)
	
	
	MOVE.W	YPADDLE,D2
	MOVE.W	XPADDLE,D1
	MOVE.L	#87,D0
	MOVE.W	D1,D3
	MOVE.W	D2,D4
	ADD.W	WIDTH,D3
	ADD.W	HEIGHT,D4
	TRAP	#15
	MOVEM.L	(A7)+,D0-D4/A1
	RTS
**************************************


***Check for collision with right side of ball and the wall****
RIGHT	MOVEM.L	D0-D1,-(A7)
	
	MOVE.W	X,D1
	ADD.W	DIAMETER,D1
	CMP.W	#639,D1
	BGE	SKIP_RIGHT3	

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	ADD.W	DIAMETER,D1
	ADD.W	#1,D1
	MOVE.W	D1,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BNE	SKIP_RIGHT1

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	ADD.W	DIAMETER,D1
	ADD.W	DIAMETER,D2
	ADD.W	#1,D1
	MOVE.W	D1,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BEQ	SKIP_RIGHT2

SKIP_RIGHT1	CMP.L	#P_COLOR,COLOUR
	BEQ	SKIP_RIGHT2

	PEA	COLOUR
	PEA	ERASEX
	BSR	ERASE_BLOCK
	LEA	(8,A7),A7

SKIP_RIGHT3	
	MOVE.W	#-1,XDIRECTION
	PLAY	#1
	
SKIP_RIGHT2	MOVEM.L	(A7)+,D0-D1
	RTS
***************************************************************


***Check for collision with left side of ball and the wall***
LEFT	MOVEM.L	D0-D3,-(A7)
	
	MOVE.W	X,D1
	CMP.W	#1,D1
	BLE	SKIP_LEFT3

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	SUB.W	#1,D1
	MOVE.W	D1,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BNE	SKIP_LEFT1

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	ADD.W	DIAMETER,D2
	SUB.W	#1,D1
	MOVE.W	D1,ERASEX
	
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BEQ	SKIP_LEFT2

SKIP_LEFT1	CMP.L	#P_COLOR,COLOUR
	BEQ	SKIP_LEFT2

	PEA	COLOUR
	PEA	ERASEX
	BSR	ERASE_BLOCK
	LEA	(8,A7),A7


SKIP_LEFT3	
	MOVE.W	#1,XDIRECTION
	PLAY	#1





SKIP_LEFT2	MOVEM.L	(A7)+,D0-D3
	RTS
*************************************************************


***Check for collision with top of ball and the ceiling****
TOP	MOVEM.L	D0-D1,-(A7)
	
	MOVE.W	Y,D1
	CMP.W	#1,D1
	BLE	SKIP_TOP3

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	SUB.W	#1,D2
	MOVE.W	X,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BNE	SKIP_TOP1

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	ADD.W	DIAMETER,D1
	MOVE.W	D1,ERASEX
	SUB.W	#1,D2
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BEQ	SKIP_TOP2
	

SKIP_TOP1	
	CMP.L	#P_COLOR,COLOUR
	BEQ	SKIP_TOP2
	PEA	COLOUR
	PEA	ERASEX
	BSR	ERASE_BLOCK
	LEA	(8,A7),A7

SKIP_TOP3	
	MOVE.W	#1,YDIRECTION
	PLAY	#1

SKIP_TOP2	MOVEM.L	(A7)+,D0-D1
	RTS
***********************************************************


***Check for collision with bottom or ball and floor or paddle***
BOTTOM	MOVEM.L	D0-D2,-(A7)
	
	MOVE.W	Y,D1
	
	ADD.W	DIAMETER,D1
	CMP.W	#470,D1
	BLT	SK_BOTTOM4

	SUB.W	#1,NUM_BALLS
	PLAY	#2
	
	
	
	

SK_BOTTOM4	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	
	ADD.W	DIAMETER,D2
	ADD.W	#1,D2
	MOVE.W	X,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BNE	SK_BOTTOM1

	MOVE.B	#83,D0
	MOVE.W	X,D1
	MOVE.W	Y,D2
	ADD.W	DIAMETER,D1
	ADD.W	DIAMETER,D2
	ADD.W	#1,D2
	MOVE.W	D1,ERASEX
	TRAP	#15
	MOVE.L	D0,COLOUR
	CMP.L	#BLACK,D0
	BEQ	SK_BOTTOM2
	

SK_BOTTOM1
	CMP.L	#P_COLOR,COLOUR
	BEQ	SK_BOTTOM3
	PEA	COLOUR
	PEA	ERASEX
	BSR	ERASE_BLOCK
	LEA	(8,A7),A7


SK_BOTTOM3	
	MOVE.W	#-1,YDIRECTION
	PLAY	#1
SK_BOTTOM2	MOVEM.L	(A7)+,D0-D2
	RTS
******************************************************************


***Calculate new position of the ball***
MOVE_BALL	MOVEM.L	D0-D3,-(A7)
	MOVE.W	X,D0
	MOVE.W	Y,D1
	MOVE.W	XMOVE,D2
	MOVE.W	YMOVE,D3
	MULS.W	XDIRECTION,D2
	MULS.W	YDIRECTION,D3
	ADD.W	D2,D0
	ADD.W	D3,D1
	MOVE.W	D0,X
	MOVE.W	D1,Y
	MOVEM.L	(A7)+,D0-D3
	RTS
****************************************

***Slow down the ball*************
STALL	MOVEM.L	D0/A0,-(A7)
	MOVE.L	(12,A7),A0
	MOVE.W	(A0),D0
STALL_LOOP	
	BSR	P_MOVE
	SUB.W	#1,D0
	BNE	STALL_LOOP	
	MOVEM.L	(A7)+,D0/A0
	RTS
**********************************

***Draw the ball at (A0,A1)*************
CIRCLE	MOVEM.L	D0-D4/A0-A1,-(A7)
	MOVE.L	(32,A7),A1
	MOVE.L	(36,A7),A0
	MOVE.W	(A0),D1
	MOVE.W	(A1),D2
	MOVE.L	#88,D0
	MOVE.L	D1,D3
	MOVE.L	D2,D4
	ADD.W	DIAMETER,D3
	ADD.W	DIAMETER,D4
	TRAP	#15
	MOVEM.L	(A7)+,D0-D4/A0-A1
	RTS
***************************************


***Change pen color and fill color to (A1)***
COLOR	MOVEM.L	D0-D1/A1,-(A7)
	MOVEM.L	(16,A7),A1
	MOVE.L	(A1),D1
	MOVE.L	#80,D0
	TRAP	#15
	MOVE.L	#81,D0
	TRAP	#15
	MOVEM.L	(A7)+,D0-D1/A1
	RTS
********************************************
X	DS.W	1
Y	DS.W	1
XMOVE	DS.W	1
YMOVE	DS.W	1
XPADDLE	DS.W	1
YPADDLE	DS.W	1
DIAMETER	DS.W	1
BALL_COLOR	DS.L	1
TIME	DS.W	1
DIRECTION	DS.W	1
SOUND	DC.B	'C:\WINDOWS\Media\Start.wav',0
WIDTH	DS.W	1
HEIGHT	DS.W	1
PADDLE_MOVE	DS.W	1
XBLOCK	DS.W	10
YBLOCK	DS.W	4
HEIGHT_B	DS.W	1
WIDTH_B	DS.W	1
ROW_COLOR	DS.L	4
ERASE	DS.L	1
COLOUR	DS.L	1
ERASEX	DS.W	1
ERASEY	DS.W	1
BLOCK_NUM	DS.B	1
MESSAGE	DC.B	'BALLS LEFT: ',0
START_MES	DC.B	'PRESS 5 TO START',0
OVER_MES	DC.B	'GAME OVER',0
LEVEL_MES	DC.B	'LEVEL: ',0
SCORE_MES	DC.B	'SCORE: ',0
CLEAR_MES	DC.B	'                                                                         ',0
TEXT_COLOR	DS.L	1
P_COLOR	DS.L	1
SOUND2	DC.B	'C:\WINDOWS\Media\chord.wav',0
SOUND3	DC.B	'C:\WINDOWS\Media\tada.wav',0
YDIRECTION	DS.W	1
XDIRECTION	DS.W	1
NUM_BALLS	DS.W	1
LEVEL_NUM	DS.B	1
POINTS	DS.L	1
SPEED_DIFF	DS.W	1
	END	START
